-- Enhance objective display
local bg = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	edgeSize = 16,
	insets = {left = 5, right = 5, top = 5, bottom = 5},
	tile = true, tileSize = 16,
}
-- Create the frame
local frame , GAB = CreateFrame("Frame", nil, UIParent), 2;
TGTradeS.extObj = frame;

-- Place it the right place
frame:SetPoint("BOTTOMLEFT", TourGuide.statusframe, "TOPLEFT", 0, -2);
frame:SetPoint("BOTTOMRIGHT", TourGuide.statusframe, "TOPRIGHT", -5);
frame:SetHeight(94);
frame:SetBackdrop(bg)
frame:SetBackdropColor(0.09, 0.09, 0.19, 0.5)
frame:SetBackdropBorderColor(0.5, 0.5, 0.5, 0.5)

frame.text = {}
for i = 1, 7, 1 do
  frame.text[i] = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal");
  if i == 1 then
    frame.text[i]:SetPoint("TOPLEFT", frame, "TOPLEFT", 6, -6);
    frame.text[i]:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -6, -6);
    frame.text[i]:Show()
  else
    frame.text[i]:SetPoint("TOPLEFT", frame.text[i - 1], "BOTTOMLEFT", 0, -GAB);
    frame.text[i]:SetPoint("TOPRIGHT", frame.text[i - 1], "BOTTOMRIGHT", 0, -GAB);
    frame.text[i]:Hide()
  end
  frame.text[i]:SetTextHeight(10);
  frame.text[i]:SetJustifyH("CENTER");
  frame.text[i]:SetJustifyV("CENTER");
  frame.text[i]:SetText("Skill 153 of 165");
  frame.text[i]:SetWordWrap(false);
end

frame:SetScript("OnShow", function(self)
  local t = TourGuide.tags[TourGuide.current]
  if t:match("|CURRENCY|") then
    self:SetHeight(22)
    self.text[1]:SetJustifyH("CENTER");
  elseif t:match("|LVLTOSKILL|") then
    local SkillName, SkillLevel = t:match("|LVLTOSKILL|([%a:'%s]+)%s?(%d+)|")
    if strtrim(SkillName) == "Skinning" then
      self:SetHeight(12 + (10 * 2) + GAB)
      self.text[1]:SetJustifyH("CENTER");
      self.text[2]:SetJustifyH("CENTER");
      self.text[2]:Show()
    else
      self:SetHeight(22)
      self.text[1]:SetJustifyH("CENTER");
    end
  elseif t:match("|LOOT|") then
    local info = { strsplit(",", t:match("|LOOT|([%d%s,]+)|") ) }
    local infoNum = #info
    -- make sure the cap is max 6
    if infoNum > 6 then infoNum = 6 end

    self:SetHeight(12 + (10 * #info) + (GAB * (#info - 1)))

    for i = 1, infoNum, 1 do
      if i == 1 then
        if infoNum == 1 then
          self.text[i]:SetJustifyH("CENTER");
        else
          self.text[i]:SetJustifyH("LEFT");
        end
      else
        self.text[i]:Show()
        self.text[i]:SetJustifyH("LEFT");
      end
    end
  elseif t:match("|TLOOT|") then
    local itemListInfo, amount = t:match("|TLOOT|([%d%s]+),%s*(%d*)|")
    local itemList = { strsplit(" ", strtrim(itemListInfo)) }
    local infoNum = #itemList
    -- make sure the cap is max 6
    if infoNum > 6 then infoNum = 6 end

    self:SetHeight(12 + (10 * (infoNum + 1)) + (GAB * infoNum))

    for i = 1, (infoNum + 1), 1 do
      if i == 1 then
        self.text[i]:SetJustifyH("CENTER");
      else
        self.text[i]:Show()
        self.text[i]:SetJustifyH("LEFT");
      end
    end
  end
end)

frame:SetScript("OnHide", function(self)
  for i = 2, 7, 1 do
    self.text[i]:Hide()
  end
end)
